using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Threading;

namespace CSharpDemo
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox textBoxOut;
		private System.Windows.Forms.Timer timerMain;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.Timer timerDotNet;
		private ZylTimer.Timer timerZyl;
		private System.ComponentModel.IContainer components;
		public int DotNetCounter = 0;
		private System.Windows.Forms.Label label1;
		public int ZylCounter = 0;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            this.timerDotNet = new System.Windows.Forms.Timer(this.components);
            this.timerZyl = new ZylTimer.Timer(this.components);
            this.textBoxOut = new System.Windows.Forms.TextBox();
            this.timerMain = new System.Windows.Forms.Timer(this.components);
            this.button1 = new System.Windows.Forms.Button();
            this.button2 = new System.Windows.Forms.Button();
            this.label1 = new System.Windows.Forms.Label();
            this.SuspendLayout();
            // 
            // timerDotNet
            // 
            this.timerDotNet.Interval = 1;
            this.timerDotNet.Tick += new System.EventHandler(this.timerDotNet_Tick);
            // 
            // timerZyl
            // 
            this.timerZyl.Cycled = true;
            this.timerZyl.Enabled = false;
            this.timerZyl.Interval = 1;
            this.timerZyl.Priority = System.Threading.ThreadPriority.Normal;
            this.timerZyl.RepeatCount = 0;
            this.timerZyl.Tick += new ZylTimer.TickEventHandler(this.timerZyl_Tick);
            // 
            // textBoxOut
            // 
            this.textBoxOut.Location = new System.Drawing.Point(8, 40);
            this.textBoxOut.Multiline = true;
            this.textBoxOut.Name = "textBoxOut";
            this.textBoxOut.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
            this.textBoxOut.Size = new System.Drawing.Size(292, 152);
            this.textBoxOut.TabIndex = 0;
            // 
            // timerMain
            // 
            this.timerMain.Interval = 1000;
            this.timerMain.Tick += new System.EventHandler(this.timerMain_Tick);
            // 
            // button1
            // 
            this.button1.Location = new System.Drawing.Point(8, 208);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(75, 23);
            this.button1.TabIndex = 1;
            this.button1.Text = "Start";
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // button2
            // 
            this.button2.Location = new System.Drawing.Point(112, 208);
            this.button2.Name = "button2";
            this.button2.Size = new System.Drawing.Size(75, 23);
            this.button2.TabIndex = 2;
            this.button2.Text = "Stop";
            this.button2.Click += new System.EventHandler(this.button2_Click);
            // 
            // label1
            // 
            this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label1.Location = new System.Drawing.Point(10, 14);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(344, 13);
            this.label1.TabIndex = 3;
            this.label1.Text = "Tick events in 1 second (.NET Timer/ZylTimer):";
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(312, 240);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.button2);
            this.Controls.Add(this.button1);
            this.Controls.Add(this.textBoxOut);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
            this.Name = "Form1";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "ZylTimer.NET Demo";
            this.Closed += new System.EventHandler(this.Form1_Closed);
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void timerMain_Tick(object sender, System.EventArgs e)
		{
			textBoxOut.Text += DotNetCounter.ToString() + " / " +
				ZylCounter.ToString() + Environment.NewLine;
			textBoxOut.SelectionStart = textBoxOut.Text.Length;
			textBoxOut.SelectionLength = 0;
			textBoxOut.ScrollToCaret();
			ZylCounter = 0;
			DotNetCounter = 0;
		}

		private void timerZyl_Tick(object sender, System.EventArgs e)
		{
			ZylCounter++;
		}

		private void timerDotNet_Tick(object sender, System.EventArgs e)
		{
			DotNetCounter++;
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			timerDotNet.Enabled = true;
			timerZyl.Enabled = true;
			timerMain.Enabled = true;
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			timerDotNet.Enabled = false;
			timerZyl.Enabled = false;
			timerMain.Enabled = false;
			ZylCounter = 0;
			DotNetCounter = 0;
		}

		private void Form1_Closed(object sender, System.EventArgs e)
		{
			if (timerZyl != null)
				timerZyl.Stop();
		}
	}
}
